/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Controle;
import com.tabajara.base.tables.records.ControleRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.sql.Date;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ControleDao extends AbstractVertxDAO<ControleRecord, com.tabajara.base.tables.pojos.Controle, Integer, Future<List<com.tabajara.base.tables.pojos.Controle>>, Future<com.tabajara.base.tables.pojos.Controle>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<ControleRecord,com.tabajara.base.tables.pojos.Controle,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public ControleDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Controle.CONTROLE, com.tabajara.base.tables.pojos.Controle.class, new JDBCClassicQueryExecutor<ControleRecord,com.tabajara.base.tables.pojos.Controle,Integer>(com.tabajara.base.tables.pojos.Controle.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Controle object) {
        return object.getConid();
    }

    /**
     * Find records that have <code>concriacao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Controle>> findManyByConcriacao(List<Date> values) {
        return findManyByCondition(Controle.CONTROLE.CONCRIACAO.in(values));
    }
}
